MeasureB <- function(B, theta, ai, zi=numeric(0), t0=0) {

# This function computes the measure beta, as the parameter for Dirichlet
# process prior.
# ai is the partition, any given >0 numbers, that need a measure computed.
# zi is the observed, uncensored data vector.
#  Added t0, the measure is generated by B*exp[- theta*(t-t0)]. So, ai must all > t0. 
#
## modified 2014.9 to have more precise outcome. with 120 bits   
 times <- sort(ai)	 
 tivec120 <- mpfr(times-t0, 120)	 
 one120 <- mpfr(1, 120)	 
 zero120 <- mpfr(0, 120)	 
 temp1 <- c(one120, exp(- theta * tivec120), zero120)   
 Malpha <- -B * diff(temp1)   
 if(length(zi)>0) {   
          if(any(is.na(zi))) stop("NA's in the zi?")
          if(any(zi<0)) stop("negative zi?")
          temp <- diff(c(length(zi),rowSums(t(outer(zi,times,FUN=">="))),0)) 
          Malpha <- Malpha - mpfr(temp, 120)
          } 
 return(Malpha)
}